SUBROUTINE Adrianne_thread_state

   USE global_variables
   IMPLICIT NONE

   INTEGER :: i,j,istate
   INTEGER :: check_adrianne

   nAdrianneStates = nAdrianneStates+1
   sudoku_Adrianne(nAdrianneStates,:,:) = sudoku
   sudoku_Adrianne_logic(nAdrianneStates,:,:,:) = sudoku_logic
   sudoku_Adrianne_logic_numbers(nAdrianneStates,:,:) = sudoku_logic_values

iloop:   DO i=1,max_grid_size1
     DO j=1,max_grid_size2
        IF (sudoku(i,j) .ne. 0) CYCLE
          check_adrianne = 0
          DO istate=1,nAdrianneStates-1
             IF ((i .eq. Adrianne_state_row(istate)) .AND. &
                  (j .eq. Adrianne_state_col(istate))) THEN
                        check_adrianne = 1
                        EXIT
             END IF
          END DO
          IF (check_adrianne .eq. 0) THEN
                Adrianne_state_row(nAdrianneStates) = i
                Adrianne_state_col(nAdrianneStates) = j
                EXIT iloop
          END IF
     END DO
  END DO iloop


END SUBROUTINE Adrianne_thread_state

!-----------------------------------------------------

SUBROUTINE check_contradiction_Adrianne(sudoku1,sudoku_logic_values1,sudoku_logic1,check_adrianne,max_grid_size11,max_grid_size21)

  USE global_variables
  IMPLICIT NONE

  INTEGER, DIMENSION(max_grid_size1,max_grid_size2) :: sudoku1
  INTEGER, DIMENSION(max_grid_size1,max_grid_size2,9) :: sudoku_logic1
  INTEGER,DIMENSION(max_grid_size1,max_grid_size2) :: sudoku_logic_values1

  INTEGER :: check_adrianne
  INTEGER :: max_grid_size11,max_grid_size21

  INTEGER,DIMENSION(9) :: row_check
  INTEGER,DIMENSION(9) :: col_check
  INTEGER :: i,j,inumber,k
  INTEGER :: small_cell_row,small_cell_column
  INTEGER :: row_k,column_k,ii_other,jj_other
  INTEGER :: ii,jj,cage_local,cage_no_of_cells_local,icell
  INTEGER :: cage_local_previous

  DO i=1,max_grid_size1
    cage_local_previous = 0
    DO j=1,max_grid_size2
      row_check = 0
      IF (sudoku1(i,j) .le. 0) CYCLE
      cage_local = cell_to_cage(i,j,1)
      IF (cage_local .eq. cage_local_previous) CYCLE
      cage_no_of_cells_local = cage_no_of_cells(cage_local)
      DO icell=1,cage_no_of_cells_local
	ii = cage_to_cells(cage_local,icell,1)
	jj = cage_to_cells(cage_local,icell,2) 
	IF (sudoku1(ii,jj) .le. 0) CYCLE
        row_check(sudoku1(ii,jj)) = row_check(sudoku1(ii,jj)) + 1
      END DO
      DO inumber=1,9
       IF(row_check(inumber) .gt. 1) THEN
         check_adrianne = 1
         RETURN
       END IF
      END DO
      cage_local_previous = cage_local
    END DO
  END DO

  DO j=1,max_grid_size2
    cage_local_previous = 0
    DO i=1,max_grid_size1
      col_check = 0
      IF (sudoku1(i,j) .le. 0) CYCLE
      cage_local = cell_to_cage(i,j,2)
      IF (cage_local .eq. cage_local_previous) CYCLE
      cage_no_of_cells_local = cage_no_of_cells(cage_local)
      DO icell=1,cage_no_of_cells_local
        ii = cage_to_cells(cage_local,icell,1)
        jj = cage_to_cells(cage_local,icell,2)
        IF (sudoku1(ii,jj) .le. 0) CYCLE
        col_check(sudoku1(ii,jj)) = col_check(sudoku1(ii,jj)) + 1
      END DO
      DO inumber=1,9
       IF(col_check(inumber) .gt. 1) THEN
         check_adrianne = 1
         RETURN
       END IF
      END DO
      cage_local_previous = cage_local
    END DO
  END DO


END SUBROUTINE check_contradiction_Adrianne

!-----------------------------------------------------------------------------------

