SUBROUTINE Crisscross_arithmetic

  USE global_variables
  IMPLICIT NONE

  INTEGER,DIMENSION(max_cages,2) :: horizontal_2cages
  INTEGER,DIMENSION(max_cages,3) :: horizontal_3cages
  INTEGER,DIMENSION(max_cages,4) :: horizontal_4cages
  INTEGER,DIMENSION(max_cages,2) :: vertical_2cages
  INTEGER,DIMENSION(max_cages,3) :: vertical_3cages
  INTEGER,DIMENSION(max_cages,4) :: vertical_4cages
  INTEGER :: nhorizontal_2cages,nvertical_2cages
  INTEGER :: nhorizontal_3cages,nvertical_3cages
  INTEGER :: nhorizontal_4cages,nvertical_4cages
  INTEGER :: i,j,cage1h,cage2h,cage1h_real,cage2h_real
  INTEGER :: cage1v,cage2v,cage1v_real,cage2v_real
  INTEGER,DIMENSION(max_grid_size1,max_grid_size2,3) :: overlap
  INTEGER :: overlapping_cells,nonoverlapping_cells_horizontal
  INTEGER :: nonoverlapping_cells_vertical,nonoverlapping_cells_total
  INTEGER,DIMENSION(10,2) :: non_overlap_cells_horizontal
  INTEGER,DIMENSION(10,2) :: non_overlap_cells_vertical
  INTEGER :: sum_horizontal,sum_vertical,difference
  INTEGER :: row1,col1,row2,col2,cell_numbers1,cell_numbers2
  INTEGER :: cell_numbers3,cell_numbers4,row3,col3,row4,col4
  INTEGER :: npossible_combination
  INTEGER,DIMENSION(9) :: empty_values1,empty_values2
  INTEGER,DIMENSION(9) :: empty_values3,empty_values4
  INTEGER :: cell_logic_number1,cell_logic_number2
  INTEGER :: cell_logic_number3,cell_logic_number4
  INTEGER :: inumber,jnumber,ivalue,icell,ncells,jcell
  INTEGER :: knumber,lnumber
  INTEGER :: ii,jj
  INTEGER :: cage3h,cage4h,cage3h_real,cage4h_real
  INTEGER :: cage3v,cage4v,cage3v_real,cage4v_real
 

  nhorizontal_2cages = 0
  nhorizontal_3cages = 0
  nhorizontal_4cages = 0
  nvertical_2cages = 0
  nvertical_3cages = 0
  nvertical_4cages = 0

  IF (nhorizontal_cages .ge. 2) THEN
    CALL Find_2permutation_horizontalcage(nhorizontal_2cages,horizontal_2cages)
  END IF
  IF (nhorizontal_cages .ge. 3) THEN
    CALL Find_3permutation_horizontalcage(nhorizontal_3cages,horizontal_3cages)
  END IF
  IF (nhorizontal_cages .ge. 4) THEN
    CALL Find_4permutation_horizontalcage(nhorizontal_4cages,horizontal_4cages)
  END IF

  CALL Find_2permutation_verticalcage(nvertical_2cages,vertical_2cages)
  CALL Find_3permutation_verticalcage(nvertical_3cages,vertical_3cages)
  CALL Find_4permutation_verticalcage(nvertical_4cages,vertical_4cages) 

  overlap = 0
  DO i=1,nhorizontal_cages
    cage1h_real = horizontal_cages(i)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_2cages
     cage1v = vertical_2cages(j,1)
     cage2v = vertical_2cages(j,2)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) 
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!----------------------------------------

  overlap = 0 
  DO i=1,nhorizontal_cages
    cage1h_real = horizontal_cages(i)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    
    DO j=1,nvertical_3cages 
     cage1v = vertical_3cages(j,1)
     cage2v = vertical_3cages(j,2)
     cage3v = vertical_3cages(j,3)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     cage3v_real = vertical_cages(cage3v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage3v_real)
     DO icell=1,ncells
	row2 = cage_to_cells(cage3v_real,icell,1)
	col2 = cage_to_cells(cage3v_real,icell,2)
	overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real) + &
			cage_sum(cage3v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!-----------------------------------------
  overlap = 0
  DO i=1,nhorizontal_cages
    cage1h_real = horizontal_cages(i)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_4cages
     cage1v = vertical_4cages(j,1)
     cage2v = vertical_4cages(j,2)
     cage3v = vertical_4cages(j,3)
     cage4v = vertical_4cages(j,4)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     cage3v_real = vertical_cages(cage3v)
     cage4v_real = vertical_cages(cage4v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage3v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage3v_real,icell,1)
        col2 = cage_to_cells(cage3v_real,icell,2)
	overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage4v_real)
     DO icell=1,ncells
	row2 = cage_to_cells(cage4v_real,icell,1)
	col2 = cage_to_cells(cage4v_real,icell,2)
	overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real) + &
                        cage_sum(cage3v_real) + cage_sum(cage4v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO


!-----------------------------------------
  overlap = 0
  DO i=1,nhorizontal_2cages
    cage1h = horizontal_2cages(i,1)
    cage2h = horizontal_2cages(i,2)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_cages
     cage1v_real = vertical_cages(j)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real)
      sum_vertical = cage_sum(cage1v_real) 

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO
  

!-----------------------------------------
  overlap = 0
  DO i=1,nhorizontal_3cages
    cage1h = horizontal_3cages(i,1)
    cage2h = horizontal_3cages(i,2)
    cage3h = horizontal_3cages(i,3)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    cage3h_real = horizontal_cages(cage3h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage3h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage3h_real,icell,1)
      col1 = cage_to_cells(cage3h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO	

    DO j=1,nvertical_cages
     cage1v_real = vertical_cages(j)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real) + &
			cage_sum(cage3h_real)
      sum_vertical = cage_sum(cage1v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!-----------------------------------------
  overlap = 0
  DO i=1,nhorizontal_4cages
    cage1h = horizontal_4cages(i,1)
    cage2h = horizontal_4cages(i,2)
    cage3h = horizontal_4cages(i,3)
    cage4h = horizontal_4cages(i,4)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    cage3h_real = horizontal_cages(cage3h)
    cage4h_real = horizontal_cages(cage4h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage3h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage3h_real,icell,1)
      col1 = cage_to_cells(cage3h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage4h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage4h_real,icell,1)
      col1 = cage_to_cells(cage4h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_cages
     cage1v_real = vertical_cages(j)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real) + &
                        cage_sum(cage3h_real) + cage_sum(cage4h_real)
      sum_vertical = cage_sum(cage1v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO


!------------------------------------------
! (2,2) case

  overlap = 0
  DO i=1,nhorizontal_2cages
    cage1h = horizontal_2cages(i,1)
    cage2h = horizontal_2cages(i,2)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells 
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_2cages
     cage1v = vertical_2cages(j,1)
     cage2v = vertical_2cages(j,2)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real)
    
      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
				sum_vertical)

    END DO
  END DO

!------------------------------------------------------
  overlap = 0
  DO i=1,nhorizontal_2cages
    cage1h = horizontal_2cages(i,1)
    cage2h = horizontal_2cages(i,2)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_3cages
     cage1v = vertical_3cages(j,1)
     cage2v = vertical_3cages(j,2)
     cage3v = vertical_3cages(j,3)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     cage3v_real = vertical_cages(cage3v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage3v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage3v_real,icell,1)
        col2 = cage_to_cells(cage3v_real,icell,2)
        overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real) + &
                        cage_sum(cage3v_real)


      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!---------------------------------------------------
  overlap = 0
  DO i=1,nhorizontal_2cages
    cage1h = horizontal_2cages(i,1)
    cage2h = horizontal_2cages(i,2)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_4cages
     cage1v = vertical_4cages(j,1)
     cage2v = vertical_4cages(j,2)
     cage3v = vertical_4cages(j,3)
     cage4v = vertical_4cages(j,4)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     cage3v_real = vertical_cages(cage3v)
     cage4v_real = vertical_cages(cage4v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage3v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage3v_real,icell,1)
        col2 = cage_to_cells(cage3v_real,icell,2)
        overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage4v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage4v_real,icell,1)
        col2 = cage_to_cells(cage4v_real,icell,2)
	overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real) + &
                        cage_sum(cage3v_real) + cage_sum(cage4v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!------------------------------------------------------

  overlap = 0
  DO i=1,nhorizontal_3cages
    cage1h = horizontal_3cages(i,1)
    cage2h = horizontal_3cages(i,2)
    cage3h = horizontal_3cages(i,3)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    cage3h_real = horizontal_cages(cage3h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage3h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage3h_real,icell,1)
      col1 = cage_to_cells(cage3h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_2cages
     cage1v = vertical_2cages(j,1)
     cage2v = vertical_2cages(j,2)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real) + &
				cage_sum(cage3h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!----------------------------------------------------
  overlap=0
  DO i=1,nhorizontal_3cages
    cage1h = horizontal_3cages(i,1)
    cage2h = horizontal_3cages(i,2)
    cage3h = horizontal_3cages(i,3)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    cage3h_real = horizontal_cages(cage3h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage3h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage3h_real,icell,1)
      col1 = cage_to_cells(cage3h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_3cages
     cage1v = vertical_3cages(j,1)
     cage2v = vertical_3cages(j,2)
     cage3v = vertical_3cages(j,3)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     cage3v_real = vertical_cages(cage3v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage3v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage3v_real,icell,1)
        col2 = cage_to_cells(cage3v_real,icell,2)
        overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real) + &
			cage_sum(cage3h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real) + &
                        cage_sum(cage3v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!----------------------------------------------------
  overlap = 0
  DO i=1,nhorizontal_3cages
    cage1h = horizontal_3cages(i,1)
    cage2h = horizontal_3cages(i,2)
    cage3h = horizontal_3cages(i,3)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    cage3h_real = horizontal_cages(cage3h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage3h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage3h_real,icell,1)
      col1 = cage_to_cells(cage3h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_4cages
     cage1v = vertical_4cages(j,1)
     cage2v = vertical_4cages(j,2)
     cage3v = vertical_4cages(j,3)
     cage4v = vertical_4cages(j,4)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     cage3v_real = vertical_cages(cage3v)
     cage4v_real = vertical_cages(cage4v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage3v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage3v_real,icell,1)
        col2 = cage_to_cells(cage3v_real,icell,2)
        overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage4v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage4v_real,icell,1)
        col2 = cage_to_cells(cage4v_real,icell,2)
	overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real) + &
			cage_sum(cage3h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real) + &
                        cage_sum(cage3v_real) + cage_sum(cage4v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!-----------------------------------------------------
  overlap = 0
  DO i=1,nhorizontal_4cages
    cage1h = horizontal_4cages(i,1)
    cage2h = horizontal_4cages(i,2)
    cage3h = horizontal_4cages(i,3)
    cage4h = horizontal_4cages(i,4)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    cage3h_real = horizontal_cages(cage3h)
    cage4h_real = horizontal_cages(cage4h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage3h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage3h_real,icell,1)
      col1 = cage_to_cells(cage3h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage4h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage4h_real,icell,1)
      col1 = cage_to_cells(cage4h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_2cages
     cage1v = vertical_2cages(j,1)
     cage2v = vertical_2cages(j,2)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real) + &
			cage_sum(cage3h_real) + cage_sum(cage4h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!----------------------------------------------------
  overlap = 0
  DO i=1,nhorizontal_4cages
    cage1h = horizontal_4cages(i,1)
    cage2h = horizontal_4cages(i,2)
    cage3h = horizontal_4cages(i,3)
    cage4h = horizontal_4cages(i,4)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    cage3h_real = horizontal_cages(cage3h)
    cage4h_real = horizontal_cages(cage4h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage3h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage3h_real,icell,1)
      col1 = cage_to_cells(cage3h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage4h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage4h_real,icell,1)
      col1 = cage_to_cells(cage4h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_3cages
     cage1v = vertical_3cages(j,1)
     cage2v = vertical_3cages(j,2)
     cage3v = vertical_3cages(j,3)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     cage3v_real = vertical_cages(cage3v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage3v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage3v_real,icell,1)
        col2 = cage_to_cells(cage3v_real,icell,2)
        overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real) + &
			cage_sum(cage3h_real) + cage_sum(cage4h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real) + &
                        cage_sum(cage3v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO

!---------------------------------------------------
  overlap = 0
  DO i=1,nhorizontal_4cages
    cage1h = horizontal_4cages(i,1)
    cage2h = horizontal_4cages(i,2)
    cage3h = horizontal_4cages(i,3)
    cage4h = horizontal_4cages(i,4)
    cage1h_real = horizontal_cages(cage1h)
    cage2h_real = horizontal_cages(cage2h)
    cage3h_real = horizontal_cages(cage3h)
    cage4h_real = horizontal_cages(cage4h)
    overlap = 0

    ncells = cage_no_of_cells(cage1h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage1h_real,icell,1)
      col1 = cage_to_cells(cage1h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage2h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage2h_real,icell,1)
      col1 = cage_to_cells(cage2h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage3h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage3h_real,icell,1)
      col1 = cage_to_cells(cage3h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO
    ncells = cage_no_of_cells(cage4h_real)
    DO icell=1,ncells
      row1 = cage_to_cells(cage4h_real,icell,1)
      col1 = cage_to_cells(cage4h_real,icell,2)
      overlap(row1,col1,1) = 1
    END DO

    DO j=1,nvertical_4cages
     cage1v = vertical_4cages(j,1)
     cage2v = vertical_4cages(j,2)
     cage3v = vertical_4cages(j,3)
     cage4v = vertical_4cages(j,4)
     cage1v_real = vertical_cages(cage1v)
     cage2v_real = vertical_cages(cage2v)
     cage3v_real = vertical_cages(cage3v)
     cage4v_real = vertical_cages(cage4v)
     overlap(:,:,2) = 0
     overlap(:,:,3) = 0

     ncells = cage_no_of_cells(cage1v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage1v_real,icell,1)
       col2 = cage_to_cells(cage1v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage2v_real)
     DO icell=1,ncells
       row2 = cage_to_cells(cage2v_real,icell,1)
       col2 = cage_to_cells(cage2v_real,icell,2)
       overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage3v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage3v_real,icell,1)
        col2 = cage_to_cells(cage3v_real,icell,2)
        overlap(row2,col2,2) = 1
     END DO
     ncells = cage_no_of_cells(cage4v_real)
     DO icell=1,ncells
        row2 = cage_to_cells(cage4v_real,icell,1)
        col2 = cage_to_cells(cage4v_real,icell,2)
	overlap(row2,col2,2) = 1
     END DO

      sum_horizontal = cage_sum(cage1h_real) + cage_sum(cage2h_real) + &
			cage_sum(cage3h_real) + cage_sum(cage4h_real)
      sum_vertical = cage_sum(cage1v_real) + cage_sum(cage2v_real) + &
                        cage_sum(cage3v_real) + cage_sum(cage4v_real)

      CALL calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

    END DO
  END DO


END SUBROUTINE Crisscross_arithmetic

!-------------------------------------------------------

SUBROUTINE calculate_crisscross_arithmetic(overlap,sum_horizontal, &
                                sum_vertical)

  USE global_variables
  IMPLICIT NONE 

  INTEGER,DIMENSION(max_cages,2) :: horizontal_2cages
  INTEGER,DIMENSION(max_cages,3) :: horizontal_3cages
  INTEGER,DIMENSION(max_cages,4) :: horizontal_4cages
  INTEGER,DIMENSION(max_cages,2) :: vertical_2cages
  INTEGER,DIMENSION(max_cages,3) :: vertical_3cages
  INTEGER,DIMENSION(max_cages,4) :: vertical_4cages
  INTEGER :: nhorizontal_2cages,nvertical_2cages
  INTEGER :: nhorizontal_3cages,nvertical_3cages
  INTEGER :: nhorizontal_4cages,nvertical_4cages
  INTEGER :: i,j,cage1h,cage2h,cage1h_real,cage2h_real
  INTEGER :: cage1v,cage2v,cage1v_real,cage2v_real
  INTEGER,DIMENSION(max_grid_size1,max_grid_size2,3) :: overlap
  INTEGER :: overlapping_cells,nonoverlapping_cells_horizontal
  INTEGER :: nonoverlapping_cells_vertical,nonoverlapping_cells_total
  INTEGER,DIMENSION(10,2) :: non_overlap_cells_horizontal
  INTEGER,DIMENSION(10,2) :: non_overlap_cells_vertical
  INTEGER :: sum_horizontal,sum_vertical,difference
  INTEGER :: row1,col1,row2,col2,cell_numbers1,cell_numbers2
  INTEGER :: cell_numbers3,cell_numbers4,row3,col3,row4,col4
  INTEGER :: npossible_combination
  INTEGER,DIMENSION(9) :: empty_values1,empty_values2
  INTEGER,DIMENSION(9) :: empty_values3,empty_values4
  INTEGER :: cell_logic_number1,cell_logic_number2
  INTEGER :: cell_logic_number3,cell_logic_number4
  INTEGER :: inumber,jnumber,ivalue,icell,ncells,jcell
  INTEGER :: knumber,lnumber
  INTEGER :: ii,jj
 
     overlapping_cells = 0
     nonoverlapping_cells_horizontal = 0
     nonoverlapping_cells_vertical = 0
     non_overlap_cells_horizontal = 0
     non_overlap_cells_vertical = 0
     DO icell=1,max_grid_size1
       DO jcell=1,max_grid_size1
         IF (overlap(icell,jcell,1) .eq. 1) THEN
	   IF (overlap(icell,jcell,2) .eq. 1) THEN
	     overlapping_cells = overlapping_cells+1
	     overlap(icell,jcell,3) = 1
	   ELSE
	     nonoverlapping_cells_horizontal = nonoverlapping_cells_horizontal + 1
	     non_overlap_cells_horizontal(nonoverlapping_cells_horizontal,1) = icell
	     non_overlap_cells_horizontal(nonoverlapping_cells_horizontal,2) = jcell
           END IF
         END IF
         IF (overlap(icell,jcell,2) .eq. 1) THEN
	   IF (overlap(icell,jcell,1) .eq. 0) THEN
             nonoverlapping_cells_vertical= nonoverlapping_cells_vertical + 1
             non_overlap_cells_vertical(nonoverlapping_cells_vertical,1) = icell
             non_overlap_cells_vertical(nonoverlapping_cells_vertical,2) = jcell
	   END IF
          END IF
        END DO
       END DO


      IF (overlapping_cells .lt. 1) RETURN
      IF (nonoverlapping_cells_horizontal + nonoverlapping_cells_vertical .gt. 4) RETURN
      IF (nonoverlapping_cells_horizontal + nonoverlapping_cells_vertical .lt. 1) RETURN
      nonoverlapping_cells_total = nonoverlapping_cells_horizontal + &
					nonoverlapping_cells_vertical
      
      IF (sum_horizontal .gt. sum_vertical) THEN
	difference = sum_horizontal - sum_vertical
      ELSE
        difference = sum_vertical - sum_horizontal
      END IF
      IF (difference .eq. 0) RETURN

      IF (nonoverlapping_cells_total .eq. 1) THEN
	IF (sum_horizontal .gt. sum_vertical) THEN
	  IF (nonoverlapping_cells_horizontal .eq.1) THEN
	    IF (sudoku(non_overlap_cells_horizontal(1,1), &
			non_overlap_cells_horizontal(1,2)) .eq. 0) THEN
             sudoku_logic_values(non_overlap_cells_horizontal(1,1), &
	    		non_overlap_cells_horizontal(1,2)) = 1
	     sudoku_logic(non_overlap_cells_horizontal(1,1), &
			non_overlap_cells_horizontal(1,2),1) = difference
	    END IF
	  ELSE
	    write(*,*) 'SOMETHING is wrong-1'
	    STOP
	  END IF
	ELSE 
          IF (nonoverlapping_cells_vertical .eq.1) THEN
	    IF (sudoku(non_overlap_cells_vertical(1,1), &
			non_overlap_cells_vertical(1,2)) .eq. 0) THEN
             sudoku_logic_values(non_overlap_cells_vertical(1,1), &
                        non_overlap_cells_vertical(1,2)) = 1
             sudoku_logic(non_overlap_cells_vertical(1,1), &
                        non_overlap_cells_vertical(1,2),1) = difference
	    END IF
          ELSE
            write(*,*) 'SOMETHING is wrong-2'
            STOP
          END IF
        END IF
      END IF

      IF (nonoverlapping_cells_total .eq. 2) THEN
        IF (nonoverlapping_cells_horizontal .eq. 2) THEN
        row1 = non_overlap_cells_horizontal(1,1)
	col1 = non_overlap_cells_horizontal(1,2)
	row2 = non_overlap_cells_horizontal(2,1)
	col2 = non_overlap_cells_horizontal(2,2)
	cell_numbers1 = sudoku_logic_values(row1,col1)
        cell_numbers2 = sudoku_logic_values(row2,col2)
        
        npossible_combination = 0
	empty_values1 = 0
	empty_values2 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
	  cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
	  cell_numbers2 = 1
	  sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF	

        DO inumber=1,cell_numbers1
         cell_logic_number1 = sudoku_logic(row1,col1,inumber)
         DO jnumber=1,cell_numbers2
          cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
           IF ((cell_logic_number1 + cell_logic_number2) .eq. difference) THEN
	     npossible_combination = npossible_combination+1
	     empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1) + 1
             empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2) + 1
           END IF
          END DO
         END DO

        IF (sudoku(row1,col1) .gt. 0) THEN
	  sudoku_logic(row1,col1,1) = 0
	END IF
	IF (sudoku(row2,col2) .gt. 0) THEN
	  sudoku_logic(row2,col2,1) = 0
 	END IF

       IF (npossible_combination .gt. 0) THEN
	IF (sudoku(row1,col1) .eq. 0) THEN 
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
	   END IF
         END DO
 	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
	    sudoku_logic(row2,col2,1) = ivalue
	  END IF
         END DO
	END IF
       END IF
       
        END IF
        IF (nonoverlapping_cells_vertical .eq. 2) THEN
         row1 = non_overlap_cells_vertical(1,1)
	 col1 = non_overlap_cells_vertical(1,2)
	 row2 = non_overlap_cells_vertical(2,1)
         col2 = non_overlap_cells_vertical(2,2)
         cell_numbers1 = sudoku_logic_values(row1,col1)
	 cell_numbers2 = sudoku_logic_values(row2,col2)

         npossible_combination = 0
         empty_values1 = 0
	 empty_values2 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF

         DO inumber=1,cell_numbers1
          cell_logic_number1 = sudoku_logic(row1,col1,inumber)
          DO jnumber = 1,cell_numbers2
           cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
	   IF ((cell_logic_number1 + cell_logic_number2) .eq. difference) THEN
	     npossible_combination = npossible_combination+1
	     empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1) + 1
 	     empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2) + 1
	   END IF 
          END DO
         END DO

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF

        IF (npossible_combination .gt. 0) THEN
	IF (sudoku(row1,col1) .eq. 0) THEN
	 DO ivalue=1,9
          IF (empty_values1(ivalue) .eq. npossible_combination) THEN
	    sudoku_logic_values(row1,col1) = 1
	    sudoku_logic(row1,col1,1) = ivalue
	  END IF
         END DO
	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
	 DO ivalue=1,9
	  IF (empty_values2(ivalue) .eq. npossible_combination) THEN
	    sudoku_logic_values(row2,col2) = 1
	    sudoku_logic(row2,col2,1) = ivalue
	  END IF
	 END DO
	END IF
        END IF

	END IF

	IF ((nonoverlapping_cells_horizontal .eq. 1) .AND. &
		(nonoverlapping_cells_vertical .eq. 1)) THEN
	  row1 = non_overlap_cells_horizontal(1,1) 
	  col1 = non_overlap_cells_horizontal(1,2)
	  row2 = non_overlap_cells_vertical(1,1)
	  col2 = non_overlap_cells_vertical(1,2)
	  cell_numbers1 = sudoku_logic_values(row1,col1)
	  cell_numbers2 = sudoku_logic_values(row2,col2)

	  npossible_combination = 0
	  empty_values1 = 0
	  empty_values2 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF

	  IF (sum_horizontal .gt. sum_vertical) THEN
	    DO inumber=1,cell_numbers1
	     cell_logic_number1 = sudoku_logic(row1,col1,inumber)
	     DO jnumber=1,cell_numbers2
	      cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
	       IF ((cell_logic_number1 - cell_logic_number2) .eq. difference) THEN
		npossible_combination = npossible_combination+1
		empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
		empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
	       END IF
	      END DO
	     END DO	
	  ELSE
            DO inumber=1,cell_numbers1
             cell_logic_number1 = sudoku_logic(row1,col1,inumber)
             DO jnumber=1,cell_numbers2
              cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
               IF ((cell_logic_number2 - cell_logic_number1) .eq. difference) THEN
                npossible_combination = npossible_combination+1
                empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
                empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
               END IF
              END DO
             END DO
	  END IF

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF

	IF (npossible_combination .gt. 0) THEN
	IF (sudoku(row1,col1) .eq. 0) THEN
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
	END IF
	END IF
	  
	END IF
      END IF

      IF (nonoverlapping_cells_total .eq. 3) THEN
       IF (nonoverlapping_cells_horizontal .eq. 3) THEN
        row1 = non_overlap_cells_horizontal(1,1)
        col1 = non_overlap_cells_horizontal(1,2)
        row2 = non_overlap_cells_horizontal(2,1)
        col2 = non_overlap_cells_horizontal(2,2)
	row3 = non_overlap_cells_horizontal(3,1)
	col3 = non_overlap_cells_horizontal(3,2)
        cell_numbers1 = sudoku_logic_values(row1,col1)
        cell_numbers2 = sudoku_logic_values(row2,col2)
 	cell_numbers3 = sudoku_logic_values(row3,col3)

        npossible_combination = 0
	empty_values1 = 0
	empty_values2 = 0
	empty_values3 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF
	IF (sudoku(row3,col3) .gt. 0) THEN
	  cell_numbers3 = 1
	  sudoku_logic(row3,col3,1) = sudoku(row3,col3)
	END IF

	DO inumber=1,cell_numbers1
         cell_logic_number1 = sudoku_logic(row1,col1,inumber)
	 DO jnumber=1,cell_numbers2
          cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
!	  IF (cell_logic_number1 .eq. cell_logic_number2) CYCLE
	  DO knumber=1,cell_numbers3
           cell_logic_number3 = sudoku_logic(row3,col3,knumber)
	   IF ((cell_logic_number1 + cell_logic_number2 + cell_logic_number3) .eq. &
			difference) THEN
	     npossible_combination=npossible_combination+1
	     empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
	     empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
	     empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
	   END IF
          END DO
         END DO
        END DO

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF
	IF (sudoku(row3,col3) .gt. 0) THEN
	  sudoku_logic(row3,col3,1) = 0
	END IF
	   
	IF (npossible_combination .gt. 0) THEN 
	IF (sudoku(row1,col1) .eq. 0) THEN
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row3,col3) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values3(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row3,col3) = 1
	    sudoku_logic(row3,col3,1) = ivalue
	  END IF
         END DO 
	END IF
	END IF

	END IF 

	IF((nonoverlapping_cells_horizontal .eq. 2) .AND. &
		(nonoverlapping_cells_vertical .eq. 1)) THEN
          row1 = non_overlap_cells_horizontal(1,1)
          col1 = non_overlap_cells_horizontal(1,2)
	  row2 = non_overlap_cells_horizontal(2,1)
	  col2 = non_overlap_cells_horizontal(2,2)
          row3 = non_overlap_cells_vertical(1,1)
          col3 = non_overlap_cells_vertical(1,2)
          cell_numbers1 = sudoku_logic_values(row1,col1)
          cell_numbers2 = sudoku_logic_values(row2,col2)
	  cell_numbers3 = sudoku_logic_values(row3,col3)

	  npossible_combination = 0
	  empty_values1 = 0
	  empty_values2 = 0
	  empty_values3 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          cell_numbers3 = 1
          sudoku_logic(row3,col3,1) = sudoku(row3,col3)
        END IF
	  
	  IF (sum_horizontal .gt. sum_vertical) THEN
	   DO inumber=1,cell_numbers1
	    cell_logic_number1 = sudoku_logic(row1,col1,inumber)
	    DO jnumber=1,cell_numbers2
             cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
             DO knumber=1,cell_numbers3
              cell_logic_number3 = sudoku_logic(row3,col3,knumber)
              IF ((cell_logic_number1 + cell_logic_number2 - cell_logic_number3) &
			.eq. difference) THEN
		npossible_combination = npossible_combination+1
		empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
		empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
		empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
	       END IF 
	      END DO
	     END DO
	    END DO
	  ELSE
	    DO inumber=1,cell_numbers1
             cell_logic_number1 = sudoku_logic(row1,col1,inumber)
	     DO jnumber=1,cell_numbers2
              cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
	      DO knumber=1,cell_numbers3
               cell_logic_number3 = sudoku_logic(row3,col3,knumber)
	       IF ((cell_logic_number3 - cell_logic_number1 - cell_logic_number2) &
			.eq. difference) THEN
		 npossible_combination = npossible_combination+1
		 empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
		 empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
		 empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
		END IF
	       END DO
	      END DO
	     END DO
          END IF

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          sudoku_logic(row3,col3,1) = 0
        END IF

	IF (npossible_combination .gt. 0) THEN
	IF (sudoku(row1,col1) .eq. 0) THEN
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row3,col3) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values3(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row3,col3) = 1
            sudoku_logic(row3,col3,1) = ivalue
          END IF
         END DO
	END IF
	END IF

        END IF
        IF((nonoverlapping_cells_horizontal .eq. 1) .AND. &
                (nonoverlapping_cells_vertical .eq. 2)) THEN
          row1 = non_overlap_cells_horizontal(1,1)
          col1 = non_overlap_cells_horizontal(1,2)
          row2 = non_overlap_cells_vertical(1,1)
          col2 = non_overlap_cells_vertical(1,2)
          row3 = non_overlap_cells_vertical(2,1)
          col3 = non_overlap_cells_vertical(2,2)
          cell_numbers1 = sudoku_logic_values(row1,col1)
          cell_numbers2 = sudoku_logic_values(row2,col2)
          cell_numbers3 = sudoku_logic_values(row3,col3)

	  npossible_combination = 0
	  empty_values1 = 0
	  empty_values2 = 0
	  empty_values3 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          cell_numbers3 = 1
          sudoku_logic(row3,col3,1) = sudoku(row3,col3)
        END IF

	  IF (sum_horizontal .gt. sum_vertical) THEN
	  DO inumber=1,cell_numbers1
	   cell_logic_number1 = sudoku_logic(row1,col1,inumber)
	   DO jnumber=1,cell_numbers2
	    cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
	    DO knumber=1,cell_numbers3
	     cell_logic_number3 = sudoku_logic(row3,col3,knumber)
	     IF ((cell_logic_number1 - cell_logic_number2 - cell_logic_number3) &
			.eq. difference) THEN
	       npossible_combination = npossible_combination+1
	       empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
	       empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
	       empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
	      END IF
             END DO
            END DO
           END DO
	  ELSE
          DO inumber=1,cell_numbers1
           cell_logic_number1 = sudoku_logic(row1,col1,inumber)
           DO jnumber=1,cell_numbers2
            cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
            DO knumber=1,cell_numbers3
             cell_logic_number3 = sudoku_logic(row3,col3,knumber)
             IF ((cell_logic_number2 + cell_logic_number3 - cell_logic_number1) &
                        .eq. difference) THEN
               npossible_combination = npossible_combination+1
               empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
               empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
               empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
              END IF
             END DO
            END DO
           END DO
          END IF

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          sudoku_logic(row3,col3,1) = 0
        END IF

	IF (npossible_combination .gt. 0) THEN
	IF (sudoku(row1,col1) .eq. 0) THEN
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row3,col3) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values3(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row3,col3) = 1
            sudoku_logic(row3,col3,1) = ivalue
          END IF
         END DO
	END IF
	END IF

        END IF
        IF (nonoverlapping_cells_vertical .eq. 3) THEN
        row1 = non_overlap_cells_vertical(1,1)
        col1 = non_overlap_cells_vertical(1,2)
        row2 = non_overlap_cells_vertical(2,1)
        col2 = non_overlap_cells_vertical(2,2)
        row3 = non_overlap_cells_vertical(3,1)
        col3 = non_overlap_cells_vertical(3,2)
        cell_numbers1 = sudoku_logic_values(row1,col1)
        cell_numbers2 = sudoku_logic_values(row2,col2)
        cell_numbers3 = sudoku_logic_values(row3,col3)

        npossible_combination = 0
        empty_values1 = 0
        empty_values2 = 0
        empty_values3 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          cell_numbers3 = 1
          sudoku_logic(row3,col3,1) = sudoku(row3,col3)
        END IF

        DO inumber=1,cell_numbers1
         cell_logic_number1 = sudoku_logic(row1,col1,inumber)
         DO jnumber=1,cell_numbers2
          cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
!          IF (cell_logic_number1 .eq. cell_logic_number2) CYCLE
          DO knumber=1,cell_numbers3
           cell_logic_number3 = sudoku_logic(row3,col3,knumber)
           IF ((cell_logic_number1 + cell_logic_number2 + cell_logic_number3) .eq. &
                        difference) THEN
             npossible_combination=npossible_combination+1
             empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
             empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
             empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
           END IF
          END DO
         END DO
        END DO

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          sudoku_logic(row3,col3,1) = 0
        END IF

	IF (npossible_combination .gt. 0) THEN
	IF (sudoku(row1,col1) .eq. 0) THEN
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row3,col3) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values3(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row3,col3) = 1
            sudoku_logic(row3,col3,1) = ivalue
          END IF
         END DO
	END IF
	END IF

        END IF
       END IF

       IF (nonoverlapping_cells_total .eq. 4) THEN
        IF ((nonoverlapping_cells_horizontal .eq. 3) .AND. &
		(nonoverlapping_cells_vertical .eq. 1)) THEN
        row1 = non_overlap_cells_horizontal(1,1)
        col1 = non_overlap_cells_horizontal(1,2)
        row2 = non_overlap_cells_horizontal(2,1)
        col2 = non_overlap_cells_horizontal(2,2)
        row3 = non_overlap_cells_horizontal(3,1)
        col3 = non_overlap_cells_horizontal(3,2)
	row4 = non_overlap_cells_vertical(1,1)
	col4 = non_overlap_cells_vertical(1,2)
        cell_numbers1 = sudoku_logic_values(row1,col1)
        cell_numbers2 = sudoku_logic_values(row2,col2)
        cell_numbers3 = sudoku_logic_values(row3,col3)
	cell_numbers4 = sudoku_logic_values(row4,col4)

	npossible_combination = 0
	empty_values1 = 0
	empty_values2 = 0
	empty_values3 = 0
	empty_values4 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          cell_numbers3 = 1
          sudoku_logic(row3,col3,1) = sudoku(row3,col3)
        END IF
	IF (sudoku(row4,col4) .gt. 0) THEN
	  cell_numbers4 = 1
	  sudoku_logic(row4,col4,1) = sudoku(row4,col4)
	END IF


       IF (sum_horizontal .gt. sum_vertical) THEN	
        DO inumber=1,cell_numbers1
         cell_logic_number1 = sudoku_logic(row1,col1,inumber)
         DO jnumber=1,cell_numbers2
          cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
          DO knumber=1,cell_numbers3
	   cell_logic_number3 = sudoku_logic(row3,col3,knumber)
	   DO lnumber=1,cell_numbers4
            cell_logic_number4 = sudoku_logic(row4,col4,lnumber)
	    IF ((cell_logic_number1 + cell_logic_number2 + cell_logic_number3 - &
			cell_logic_number4) .eq. difference) THEN
	      npossible_combination = npossible_combination+1
	      empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
	      empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
	      empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
	      empty_values4(cell_logic_number4) = empty_values4(cell_logic_number4)+1
	    END IF
	   END DO
          END DO
         END DO
        END DO
       ELSE
        DO inumber=1,cell_numbers1
         cell_logic_number1 = sudoku_logic(row1,col1,inumber)
         DO jnumber=1,cell_numbers2
          cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
          DO knumber=1,cell_numbers3
           cell_logic_number3 = sudoku_logic(row3,col3,knumber)
           DO lnumber=1,cell_numbers4
            cell_logic_number4 = sudoku_logic(row4,col4,lnumber)
            IF ((cell_logic_number4 - cell_logic_number1 - cell_logic_number2 - &
                        cell_logic_number3) .eq. difference) THEN
              npossible_combination = npossible_combination+1
              empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
              empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
              empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
              empty_values4(cell_logic_number4) = empty_values4(cell_logic_number4)+1
            END IF
           END DO
          END DO
         END DO
        END DO
       END IF

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          sudoku_logic(row3,col3,1) = 0
        END IF
	IF (sudoku(row4,col4) .gt. 0) THEN
	  sudoku_logic(row4,col4,1) = 0
	END IF

	IF (npossible_combination .gt. 0) THEN
	IF (sudoku(row1,col1) .eq. 0) THEN
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row3,col3) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values3(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row3,col3) = 1
            sudoku_logic(row3,col3,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row4,col4) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values4(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row4,col4) = 1
            sudoku_logic(row4,col4,1) = ivalue
          END IF
         END DO
	END IF
	END IF

	END IF
        IF ((nonoverlapping_cells_horizontal .eq. 2) .AND. &
                (nonoverlapping_cells_vertical .eq. 2)) THEN
        row1 = non_overlap_cells_horizontal(1,1)
        col1 = non_overlap_cells_horizontal(1,2)
        row2 = non_overlap_cells_horizontal(2,1)
        col2 = non_overlap_cells_horizontal(2,2)
        row3 = non_overlap_cells_vertical(1,1)
        col3 = non_overlap_cells_vertical(1,2)
        row4 = non_overlap_cells_vertical(2,1)
        col4 = non_overlap_cells_vertical(2,2)
        cell_numbers1 = sudoku_logic_values(row1,col1)
        cell_numbers2 = sudoku_logic_values(row2,col2)
        cell_numbers3 = sudoku_logic_values(row3,col3)
        cell_numbers4 = sudoku_logic_values(row4,col4)

        npossible_combination = 0
        empty_values1 = 0
        empty_values2 = 0
        empty_values3 = 0
	empty_values4 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          cell_numbers3 = 1
          sudoku_logic(row3,col3,1) = sudoku(row3,col3)
        END IF
        IF (sudoku(row4,col4) .gt. 0) THEN
          cell_numbers4 = 1
          sudoku_logic(row4,col4,1) = sudoku(row4,col4)
        END IF

	IF (sum_horizontal .gt. sum_vertical) THEN
         DO inumber=1,cell_numbers1
          cell_logic_number1 = sudoku_logic(row1,col1,inumber)
          DO jnumber=1,cell_numbers2
           cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
           DO knumber=1,cell_numbers3
            cell_logic_number3 = sudoku_logic(row3,col3,knumber)
            DO lnumber=1,cell_numbers4
	     cell_logic_number4 = sudoku_logic(row4,col4,lnumber)
	     IF ((cell_logic_number1+cell_logic_number2-cell_logic_number3 - &
			cell_logic_number4) .eq. difference) THEN
		npossible_combination = npossible_combination+1
		empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
		empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
		empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
		empty_values4(cell_logic_number4) = empty_values4(cell_logic_number4)+1
	     END IF
	    END DO
           END DO
          END DO
         END DO
        ELSE
         DO inumber=1,cell_numbers1
          cell_logic_number1 = sudoku_logic(row1,col1,inumber)
          DO jnumber=1,cell_numbers2
           cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
           DO knumber=1,cell_numbers3
            cell_logic_number3 = sudoku_logic(row3,col3,knumber)
            DO lnumber=1,cell_numbers4
             cell_logic_number4 = sudoku_logic(row4,col4,lnumber)
             IF ((cell_logic_number3+cell_logic_number4-cell_logic_number1 - &
                        cell_logic_number2) .eq. difference) THEN
                npossible_combination = npossible_combination+1
                empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
                empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
                empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
                empty_values4(cell_logic_number4) = empty_values4(cell_logic_number4)+1
             END IF
            END DO
           END DO
          END DO
         END DO
	END IF

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          sudoku_logic(row3,col3,1) = 0
        END IF
        IF (sudoku(row4,col4) .gt. 0) THEN
          sudoku_logic(row4,col4,1) = 0
        END IF

       IF (npossible_combination .gt. 0) THEN
	IF (sudoku(row1,col1) .eq. 0) THEN
        DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row3,col3) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values3(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row3,col3) = 1
            sudoku_logic(row3,col3,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row4,col4) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values4(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row4,col4) = 1
            sudoku_logic(row4,col4,1) = ivalue
          END IF
         END DO
	END IF
	END IF

        END IF
       IF ((nonoverlapping_cells_horizontal .eq. 1) .AND. &
                (nonoverlapping_cells_vertical .eq. 3)) THEN
        row1 = non_overlap_cells_horizontal(1,1)
        col1 = non_overlap_cells_horizontal(1,2)
        row2 = non_overlap_cells_vertical(1,1)
        col2 = non_overlap_cells_vertical(1,2)
        row3 = non_overlap_cells_vertical(2,1)
        col3 = non_overlap_cells_vertical(2,2)
        row4 = non_overlap_cells_vertical(3,1)
        col4 = non_overlap_cells_vertical(3,2)
        cell_numbers1 = sudoku_logic_values(row1,col1)
        cell_numbers2 = sudoku_logic_values(row2,col2)
        cell_numbers3 = sudoku_logic_values(row3,col3)
        cell_numbers4 = sudoku_logic_values(row4,col4)

        npossible_combination = 0
        empty_values1 = 0
        empty_values2 = 0
        empty_values3 = 0
        empty_values4 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          cell_numbers3 = 1
          sudoku_logic(row3,col3,1) = sudoku(row3,col3)
        END IF
        IF (sudoku(row4,col4) .gt. 0) THEN
          cell_numbers4 = 1
          sudoku_logic(row4,col4,1) = sudoku(row4,col4)
        END IF

       IF (sum_horizontal .gt. sum_vertical) THEN
        DO inumber=1,cell_numbers1
         cell_logic_number1 = sudoku_logic(row1,col1,inumber)
         DO jnumber=1,cell_numbers2
          cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
          DO knumber=1,cell_numbers3
           cell_logic_number3 = sudoku_logic(row3,col3,knumber)
           DO lnumber=1,cell_numbers4
            cell_logic_number4 = sudoku_logic(row4,col4,lnumber)
            IF ((cell_logic_number1 - cell_logic_number2 - cell_logic_number3 - &
                        cell_logic_number4) .eq. difference) THEN
              npossible_combination = npossible_combination+1
              empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
              empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
              empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
              empty_values4(cell_logic_number4) = empty_values4(cell_logic_number4)+1
            END IF
           END DO
          END DO
         END DO
        END DO
       ELSE
        DO inumber=1,cell_numbers1
         cell_logic_number1 = sudoku_logic(row1,col1,inumber)
         DO jnumber=1,cell_numbers2
          cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
          DO knumber=1,cell_numbers3
           cell_logic_number3 = sudoku_logic(row3,col3,knumber)
           DO lnumber=1,cell_numbers4
            cell_logic_number4 = sudoku_logic(row4,col4,lnumber)
            IF ((cell_logic_number2 + cell_logic_number3 + cell_logic_number4 - &
                        cell_logic_number1) .eq. difference) THEN
              npossible_combination = npossible_combination+1
              empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
              empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
              empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
              empty_values4(cell_logic_number4) = empty_values4(cell_logic_number4)+1
            END IF
           END DO
          END DO
         END DO
        END DO
       END IF

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          sudoku_logic(row3,col3,1) = 0
        END IF
        IF (sudoku(row4,col4) .gt. 0) THEN
          sudoku_logic(row4,col4,1) = 0
        END IF

	IF (npossible_combination .gt. 0) THEN
	IF (sudoku(row1,col1) .eq. 0) THEN
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
	END IF
	IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row3,col3) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values3(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row3,col3) = 1
            sudoku_logic(row3,col3,1) = ivalue
          END IF
         END DO
	END IF
	IF (sudoku(row4,col4) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values4(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row4,col4) = 1
            sudoku_logic(row4,col4,1) = ivalue
          END IF
         END DO
	END IF
	END IF

        END IF

       IF (nonoverlapping_cells_horizontal .eq. 4) THEN
        row1 = non_overlap_cells_horizontal(1,1)
        col1 = non_overlap_cells_horizontal(1,2)
        row2 = non_overlap_cells_horizontal(2,1)
        col2 = non_overlap_cells_horizontal(2,2)
        row3 = non_overlap_cells_horizontal(3,1)
        col3 = non_overlap_cells_horizontal(3,2)
	row4 = non_overlap_cells_horizontal(4,1)
	col4 = non_overlap_cells_horizontal(4,2)
        cell_numbers1 = sudoku_logic_values(row1,col1)
        cell_numbers2 = sudoku_logic_values(row2,col2)
        cell_numbers3 = sudoku_logic_values(row3,col3)
	cell_numbers4 = sudoku_logic_values(row4,col4)

        npossible_combination = 0
        empty_values1 = 0
        empty_values2 = 0
        empty_values3 = 0
	empty_values4 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          cell_numbers3 = 1
          sudoku_logic(row3,col3,1) = sudoku(row3,col3)
        END IF
	IF (sudoku(row4,col4) .gt. 0) THEN
	  cell_numbers4 = 1
          sudoku_logic(row4,col4,1) = sudoku(row4,col4)
	END IF

        DO inumber=1,cell_numbers1
         cell_logic_number1 = sudoku_logic(row1,col1,inumber)
         DO jnumber=1,cell_numbers2
          cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
!          IF (cell_logic_number1 .eq. cell_logic_number2) CYCLE
          DO knumber=1,cell_numbers3
           cell_logic_number3 = sudoku_logic(row3,col3,knumber)
	   DO lnumber=1,cell_numbers4
	    cell_logic_number4 = sudoku_logic(row4,col4,lnumber)
           IF ((cell_logic_number1 + cell_logic_number2 + cell_logic_number3 + &
				cell_logic_number4) .eq. &
                        difference) THEN
             npossible_combination=npossible_combination+1
             empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
             empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
             empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
	     empty_values4(cell_logic_number4) = empty_values4(cell_logic_number4)+1
           END IF
          END DO
         END DO
        END DO
       END DO

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          sudoku_logic(row3,col3,1) = 0
        END IF
        IF (sudoku(row4,col4) .gt. 0) THEN
	  sudoku_logic(row4,col4,1) = 0
	END IF

        IF (npossible_combination .gt. 0) THEN
        IF (sudoku(row1,col1) .eq. 0) THEN
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
        END IF
        IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
        END IF
        IF (sudoku(row3,col3) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values3(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row3,col3) = 1
            sudoku_logic(row3,col3,1) = ivalue
          END IF
         END DO
        END IF
	IF (sudoku(row4,col4) .eq. 0) THEN
	 DO ivalue=1,9
	  IF (empty_values4(ivalue) .eq. npossible_combination) THEN
	    sudoku_logic_values(row4,col4) = 1
	    sudoku_logic(row4,col4,1) = ivalue
	  END IF
	 END DO
	END IF
        END IF

        END IF

        IF (nonoverlapping_cells_vertical .eq. 4) THEN
        row1 = non_overlap_cells_vertical(1,1)
        col1 = non_overlap_cells_vertical(1,2)
        row2 = non_overlap_cells_vertical(2,1)
        col2 = non_overlap_cells_vertical(2,2)
        row3 = non_overlap_cells_vertical(3,1)
        col3 = non_overlap_cells_vertical(3,2)
	row4 = non_overlap_cells_vertical(4,1)
	col4 = non_overlap_cells_vertical(4,2)
        cell_numbers1 = sudoku_logic_values(row1,col1)
        cell_numbers2 = sudoku_logic_values(row2,col2)
        cell_numbers3 = sudoku_logic_values(row3,col3)
	cell_numbers4 = sudoku_logic_values(row4,col4)

        npossible_combination = 0
        empty_values1 = 0
        empty_values2 = 0
        empty_values3 = 0
	empty_values4 = 0

        IF (sudoku(row1,col1) .gt. 0) THEN
          cell_numbers1 = 1
          sudoku_logic(row1,col1,1) = sudoku(row1,col1)
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          cell_numbers2 = 1
          sudoku_logic(row2,col2,1) = sudoku(row2,col2)
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          cell_numbers3 = 1
          sudoku_logic(row3,col3,1) = sudoku(row3,col3)
        END IF
	IF (sudoku(row4,col4) .gt. 0) THEN
	  cell_numbers4 = 1
	  sudoku_logic(row4,col4,1) = sudoku(row4,col4)
	END IF

        DO inumber=1,cell_numbers1
         cell_logic_number1 = sudoku_logic(row1,col1,inumber)
         DO jnumber=1,cell_numbers2
          cell_logic_number2 = sudoku_logic(row2,col2,jnumber)
!          IF (cell_logic_number1 .eq. cell_logic_number2) CYCLE
          DO knumber=1,cell_numbers3
           cell_logic_number3 = sudoku_logic(row3,col3,knumber)
	   DO lnumber=1,cell_numbers4
	    cell_logic_number4 = sudoku_logic(row4,col4,lnumber)
           IF ((cell_logic_number1 + cell_logic_number2 + cell_logic_number3 + &
			cell_logic_number4) .eq. &
                        difference) THEN
             npossible_combination=npossible_combination+1
             empty_values1(cell_logic_number1) = empty_values1(cell_logic_number1)+1
             empty_values2(cell_logic_number2) = empty_values2(cell_logic_number2)+1
             empty_values3(cell_logic_number3) = empty_values3(cell_logic_number3)+1
	     empty_values4(cell_logic_number4) = empty_values4(cell_logic_number4)+1
           END IF
          END DO
         END DO
        END DO
       END DO

        IF (sudoku(row1,col1) .gt. 0) THEN
          sudoku_logic(row1,col1,1) = 0
        END IF
        IF (sudoku(row2,col2) .gt. 0) THEN
          sudoku_logic(row2,col2,1) = 0
        END IF
        IF (sudoku(row3,col3) .gt. 0) THEN
          sudoku_logic(row3,col3,1) = 0
        END IF
	IF (sudoku(row4,col4) .gt. 0) THEN
	  sudoku_logic(row4,col4,1) = 0
	END IF

        IF (npossible_combination .gt. 0) THEN
        IF (sudoku(row1,col1) .eq. 0) THEN
         DO ivalue=1,9
           IF (empty_values1(ivalue) .eq. npossible_combination) THEN
             sudoku_logic_values(row1,col1) = 1
             sudoku_logic(row1,col1,1) = ivalue
           END IF
         END DO
        END IF
        IF (sudoku(row2,col2) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values2(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row2,col2) = 1
            sudoku_logic(row2,col2,1) = ivalue
          END IF
         END DO
        END IF
        IF (sudoku(row3,col3) .eq. 0) THEN
         DO ivalue=1,9
          IF (empty_values3(ivalue) .eq. npossible_combination) THEN
            sudoku_logic_values(row3,col3) = 1
            sudoku_logic(row3,col3,1) = ivalue
          END IF
         END DO
        END IF
	IF (sudoku(row4,col4) .eq. 0) THEN
	 DO ivalue=1,9
	  IF (empty_values4(ivalue) .eq. npossible_combination) THEN
	   sudoku_logic_values(row4,col4) = 1
	   sudoku_logic(row4,col4,1) = ivalue
	  END IF
	 END DO
	END IF
        END IF

        END IF
       END IF


END SUBROUTINE calculate_crisscross_arithmetic

!------------------------------------------

SUBROUTINE Find_2permutation_horizontalcage(nhorizontal_2cages,horizontal_2cages)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: nhorizontal_2cages
  INTEGER,DIMENSION(max_cages,2) :: horizontal_2cages

  INTEGER :: i,j
  
  DO i=1,nhorizontal_cages-1
    DO j=i+1,nhorizontal_cages
     nhorizontal_2cages = nhorizontal_2cages + 1
      horizontal_2cages(nhorizontal_2cages,1) = i
      horizontal_2cages(nhorizontal_2cages,2) = j
    END DO
  END DO


END SUBROUTINE Find_2permutation_horizontalcage

!------------------------------------------

SUBROUTINE Find_3permutation_horizontalcage(nhorizontal_3cages,horizontal_3cages)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: nhorizontal_3cages
  INTEGER,DIMENSION(max_cages,3) :: horizontal_3cages
  INTEGER :: i,j,k
 
  DO i=1,nhorizontal_cages-2
    DO j=i+1,nhorizontal_cages-1
      DO k=j+1,nhorizontal_cages
	nhorizontal_3cages = nhorizontal_3cages + 1
	horizontal_3cages(nhorizontal_3cages,1) = i
	horizontal_3cages(nhorizontal_3cages,2) = j
	horizontal_3cages(nhorizontal_3cages,3) = k
       END DO
      END DO
    END DO


END SUBROUTINE Find_3permutation_horizontalcage

!------------------------------------------

SUBROUTINE Find_4permutation_horizontalcage(nhorizontal_4cages,horizontal_4cages)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: nhorizontal_4cages
  INTEGER,DIMENSION(max_cages,4) :: horizontal_4cages
  INTEGER :: i,j,k,l

  DO i=1,nhorizontal_cages-3
   DO j=i+1,nhorizontal_cages-2
    DO k=j+1,nhorizontal_cages-1
     DO l=k+1,nhorizontal_cages
       nhorizontal_4cages = nhorizontal_4cages + 1
       horizontal_4cages(nhorizontal_4cages,1) = i
       horizontal_4cages(nhorizontal_4cages,2) = j
       horizontal_4cages(nhorizontal_4cages,3) = k
       horizontal_4cages(nhorizontal_4cages,4) = l
      END DO
     END DO
    END DO
   END DO


END SUBROUTINE Find_4permutation_horizontalcage

!-------------------------------------------

SUBROUTINE Find_2permutation_verticalcage(nvertical_2cages,vertical_2cages)

  USE global_variables
  IMPLICIT NONE
 
  INTEGER :: nvertical_2cages
  INTEGER,DIMENSION(max_cages,2) :: vertical_2cages

  INTEGER :: i,j

  DO i=1,nvertical_cages-1
   DO j=i+1,nvertical_cages
    nvertical_2cages = nvertical_2cages+1
    vertical_2cages(nvertical_2cages,1) = i
    vertical_2cages(nvertical_2cages,2) = j
   END DO
  END DO
 

END SUBROUTINE Find_2permutation_verticalcage

!-------------------------------------------

SUBROUTINE Find_3permutation_verticalcage(nvertical_3cages,vertical_3cages)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: nvertical_3cages
  INTEGER,DIMENSION(max_cages,3) :: vertical_3cages
  INTEGER :: i,j,k

  DO i=1,nvertical_cages-2
   DO j=i+1,nvertical_cages-1
    DO k=j+1,nvertical_cages
      nvertical_3cages = nvertical_3cages + 1
      vertical_3cages(nvertical_3cages,1) = i
      vertical_3cages(nvertical_3cages,2) = j
      vertical_3cages(nvertical_3cages,3) = k
     END DO
    END DO
   END DO

END SUBROUTINE Find_3permutation_verticalcage

!-----------------------------------------

SUBROUTINE Find_4permutation_verticalcage(nvertical_4cages,vertical_4cages)

  USE global_variables
  IMPLICIT NONE

  INTEGER :: nvertical_4cages
  INTEGER,DIMENSION(max_cages,4) :: vertical_4cages
  INTEGER :: i,j,k,l

  DO i=1,nvertical_cages-3
   DO j=i+1,nvertical_cages-2
    DO k=j+1,nvertical_cages-1
     DO l=k+1,nvertical_cages
       nvertical_4cages = nvertical_4cages + 1
       vertical_4cages(nvertical_4cages,1) = i
       vertical_4cages(nvertical_4cages,2) = j
       vertical_4cages(nvertical_4cages,3) = k
       vertical_4cages(nvertical_4cages,4) = l
      END DO
     END DO
    END DO
   END DO


END SUBROUTINE Find_4permutation_verticalcage

!----------------------------------------
